VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DockForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' ******************************************************************************
' Class:             DockForm
' Description:       Save the form properties and information to be used
'                    by the docking engine
' Created by:        Marclei V Silva
' Machine:           ZEUS
' Date-Time:         09/05/20003:09:33
' Last modification:
' ******************************************************************************
Option Explicit

Private WithEvents m_c As cSizeMoveHelper
Attribute m_c.VB_VarHelpID = -1
Private m_bDragging As Boolean

' Docked Form Skin
Private Const SHOW_NORMAL = 0
Private Const SHOW_TRANSPARENT = 1
Private ActiveHost As TabDockHost

'// local variable(s) to hold property value(s)
Private mWndProcOrg As Long
Private m_DockWindow As Long
Private m_AllowDockTop As Boolean
Private m_AllowDockLeft As Boolean
Private m_AllowDockBottom As Boolean
Private m_AllowDockRight As Boolean
Private m_AllowFloat As Boolean
Private m_lFloatingWidth As Long 'local copy
Private m_lFloatingHeight As Long 'local copy
Private m_lFloatingLeft As Long 'local copy
Private m_lFloatingTop As Long 'local copy

'local variable(s) to hold property value(s)
Private mvarState As eDockedState 'local copy
Private mvarDockWindowHost As TabDockHost 'local copy
'local variable(s) to hold property value(s)
Private mvarKey As String 'local copy

Public Property Let Key(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Key = 5
    mvarKey = vData
End Property

Public Property Get Key() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Key
    Key = mvarKey
End Property

Public Property Let FloatingHeight(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FloatingHeight = 5
    m_lFloatingHeight = vData
End Property


Public Property Get FloatingHeight() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FloatingHeight
    FloatingHeight = m_lFloatingHeight
End Property

Public Property Let FloatingWidth(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FloatingWidth = 5
    m_lFloatingWidth = vData
End Property

Public Property Get FloatingWidth() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FloatingWidth
    FloatingWidth = m_lFloatingWidth
End Property

Public Property Let FloatingLEft(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FloatingLEft = 5
    m_lFloatingLeft = vData
End Property

Public Property Get FloatingLEft() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FloatingLEft
    FloatingLEft = m_lFloatingLeft
End Property

Public Property Let FloatingTop(ByVal vData As Long)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.FloatingTop = 5
    m_lFloatingTop = vData
End Property

Public Property Get FloatingTop() As Long
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.FloatingTop
    FloatingTop = m_lFloatingTop
End Property

Public Property Set DockWindowHost(ByVal vData As TabDockHost)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.DockWindowHost = Form1
    Set mvarDockWindowHost = vData
End Property

Public Property Get DockWindowHost() As TabDockHost
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.DockWindowHost
    Set DockWindowHost = mvarDockWindowHost
End Property

Public Property Let State(ByVal vData As eDockedState)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.State = Form1
    mvarState = vData
End Property

Public Property Get State() As eDockedState
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.State
    State = mvarState
End Property

Public Property Let AllowFloat(ByVal vData As Boolean)
    m_AllowFloat = vData
End Property

Public Property Get AllowFloat() As Boolean
    AllowFloat = m_AllowFloat
End Property

Public Property Let AllowDockRight(ByVal vData As Boolean)
    m_AllowDockRight = vData
End Property

Public Property Get AllowDockRight() As Boolean
    AllowDockRight = m_AllowDockRight
End Property

Public Property Let AllowDockBottom(ByVal vData As Boolean)
    m_AllowDockBottom = vData
End Property

Public Property Get AllowDockBottom() As Boolean
    AllowDockBottom = m_AllowDockBottom
End Property

Public Property Let AllowDockLeft(ByVal vData As Boolean)
    m_AllowDockLeft = vData
End Property

Public Property Get AllowDockLeft() As Boolean
    AllowDockLeft = m_AllowDockLeft
End Property

Public Property Let AllowDockTop(ByVal vData As Boolean)
    m_AllowDockTop = vData
End Property

Public Property Get AllowDockTop() As Boolean
    AllowDockTop = m_AllowDockTop
End Property

Public Property Let DockWindow(ByVal vData As Long)
    m_DockWindow = vData
    m_c.Attach vData
End Property

Public Property Get DockWindow() As Long
    DockWindow = m_DockWindow
End Property

Private Sub Class_Terminate()
   Set m_c = Nothing
End Sub

Private Sub Class_Initialize()
   Set m_c = New cSizeMoveHelper
   m_c.NoFullDrag = True
End Sub

Private Sub StoreFloatingPos(lLeft As Long, lTop As Long, lWidth As Long, lHeight As Long)
    m_lFloatingLeft = lLeft
    m_lFloatingTop = lTop
    m_lFloatingWidth = lWidth
    m_lFloatingHeight = lHeight
End Sub

Private Sub m_c_DblClick()
    If State = docked Then
        MoveWindow m_DockWindow, _
            m_lFloatingLeft, _
            m_lFloatingTop, _
            m_lFloatingWidth, _
            m_lFloatingHeight, _
            1
        mvarDockWindowHost.UnDockShow m_DockWindow
        State = undocked
    Else
        mvarDockWindowHost.Dock m_DockWindow, vbAlignLeft
        State = docked
    End If
End Sub

Private Sub m_c_FormDrag(FormLeft As Long, formTop As Long, FormWidth As Long, FormHeight As Long)
    m_bDragging = True
End Sub

Private Sub m_c_FormDropped(FormLeft As Long, formTop As Long, FormWidth As Long, FormHeight As Long)
    Dim rc As RECT
    Dim Panels As Variant
    Dim i As Integer
    Dim j As Integer
    Dim Found As Boolean
    Dim pt As POINTAPI
    
    ' If no host was found to dock the window then undock if
    ' if it is not docked
    If ActiveHost Is Nothing Then
        If State = docked Then
            mvarDockWindowHost.UnDockShow m_DockWindow
            State = undocked
        End If
        Exit Sub
    End If
    ' get the Panel list from TabDock
    Panels = mvarDockWindowHost.Parent.Panels
    If State = undocked Then
        State = docked
        ActiveHost.Dock m_DockWindow, ActiveHost.Align
        Found = True
    ElseIf State = docked Then
        If ActiveHost Is mvarDockWindowHost Then
            ActiveHost.DockResize
            ActiveHost.Arrange
        Else
            For j = 1 To 4
                If Not Panels(j) Is Nothing Then
                    If Panels(j).IsDocked(m_DockWindow) Then
                        Panels(j).UnDockShow m_DockWindow
                        Exit For
                    End If
                End If
            Next
            ActiveHost.Dock m_DockWindow, ActiveHost.Align
        End If
        Found = True
    End If
    ' A docking site was found then we must set
    ' the new dock host for this window
    Set mvarDockWindowHost = ActiveHost
    ' clean it up
    Set ActiveHost = Nothing
End Sub

Private Sub m_c_FormMoved(ByRef FormLeft As Long, ByRef formTop As Long, ByRef FormWidth As Long, ByRef FormHeight As Long)
    
    Dim rc As RECT
    Dim Panels As Variant
    Dim i As Integer
    Dim Found As Boolean
    Dim pt As POINTAPI
    Dim lXOffset As Long
    Dim lYOffset As Long
    Dim lObjWidth As Long
    Dim lObjHeight As Long
    
    Found = False
    Panels = mvarDockWindowHost.Parent.Panels
    GetCursorPos pt
    For i = 1 To 4
        If Not Panels(i) Is Nothing Then
            GetWindowRect Panels(i).hwnd, rc
            ' check if the form is in the panel's boundaries
            GetCursorPos pt
            If PtInRect(rc, pt.X, pt.Y) Then
                If Not Panels(i) Is ActiveHost Then
                    Set ActiveHost = Panels(i)
                    ' if we don't have a dragging boundary set yet
                    ' make it the rect dimensions
                    lObjWidth = rc.Right - rc.Left
                    lObjHeight = rc.Bottom - rc.Top
                    lXOffset = (pt.X - rc.Left) / 2
                    lYOffset = pt.Y - rc.Top
                    FormLeft = pt.X - lXOffset
                    FormWidth = lObjWidth
                    FormHeight = lObjHeight
                End If
                Found = True
            End If
        End If
        If Found Then Exit For
    Next
    ' if the form did not find any panel to dock in
    ' then let the rectangle image the same as its floating
    ' original rectangle
    If Not Found Then
        If m_bDragging And State = docked Then
            lXOffset = (pt.X - m_lFloatingLeft) / 2
            'lYOffset = pt.Y - m_lFloatingTop
            'FormLeft = pt.X - lXOffset
            If i = vbAlignLeft Then
                FormLeft = pt.X - lXOffset
            ElseIf i = vbAlignRight Then
                FormLeft = pt.X + lXOffset
            End If
            'formTop = pt.Y - lYOffset
            m_bDragging = False
        Else
            ' save floating position
            StoreFloatingPos FormLeft, formTop, m_lFloatingWidth, m_lFloatingHeight
        End If
        FormWidth = m_lFloatingWidth
        FormHeight = m_lFloatingHeight
        Set ActiveHost = Nothing
    End If
End Sub

Private Sub m_c_Moving(lLeft As Long, lTop As Long, lWidth As Long, lHeight As Long)
    ' save floating position
    StoreFloatingPos lLeft, lTop, lWidth, lHeight
End Sub

Private Sub m_c_Sizing(lLeft As Long, lTop As Long, lWidth As Long, lHeight As Long)
    ' save floating position
    StoreFloatingPos lLeft, lTop, lWidth, lHeight
End Sub

'-- shows the docked form no matter it is docked or undocked
Public Sub Show()
    ShowWindow m_DockWindow, SW_SHOW
    mvarDockWindowHost.DockResize
    mvarDockWindowHost.Arrange
End Sub

'-- hides the docked form no matter it is docked or undocked
Public Sub Hide()
    ShowWindow m_DockWindow, SW_HIDE
    mvarDockWindowHost.DockResize
    mvarDockWindowHost.Arrange
End Sub

'-- dock the form
Public Sub Dock()
    mvarDockWindowHost.Dock m_DockWindow, mvarDockWindowHost.Align
End Sub

'-- undock the form
Public Sub UnDock()
    MoveWindow m_DockWindow, m_lFloatingLeft, m_lFloatingTop, m_lFloatingWidth, m_lFloatingHeight, True
    mvarDockWindowHost.UnDockShow m_DockWindow
End Sub
