VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DockedForms"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"DockForm"
Attribute VB_Ext_KEY = "Member0" ,"DockForm"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' ******************************************************************************
' Class:             DockedForm
' Description:       Collection of Docked Forms, used by TabDock
'                    to keep track of the forms that is part of the
'                    engine.
' Created by:        Marclei V Silva
' Machine:           ZEUS
' Date-Time:         09/05/20003:07:33
' Last modification: 09/05/20003:07:33
' ******************************************************************************

Option Explicit

'local variable to hold collection
Private mCol As Collection

Public Function Add(DockWindow As Long, DockWindowHost As Object, AllowDockTop As Boolean, AllowDockLeft As Boolean, AllowDockBottom As Boolean, AllowDockRight As Boolean, AllowFloat As Boolean, State As eDockedState, Width As Long, Height As Long, Left As Long, Top As Long, Optional sKey As String) As DockForm
    'create a new object
    Dim objNewMember As DockForm
    Set objNewMember = New DockForm

    'set the properties passed into the method
    objNewMember.DockWindow = DockWindow
    Set objNewMember.DockWindowHost = DockWindowHost
    objNewMember.AllowDockTop = AllowDockTop
    objNewMember.AllowDockLeft = AllowDockLeft
    objNewMember.AllowDockBottom = AllowDockBottom
    objNewMember.AllowDockRight = AllowDockRight
    objNewMember.AllowFloat = AllowFloat
    objNewMember.State = State
    objNewMember.FloatingWidth = Width / Screen.TwipsPerPixelX
    objNewMember.FloatingHeight = Height / Screen.TwipsPerPixelY
    objNewMember.FloatingLEft = Left / Screen.TwipsPerPixelX
    objNewMember.FloatingTop = Top / Screen.TwipsPerPixelY
    objNewMember.Key = sKey
    
    If Len(sKey) = 0 Then
        mCol.Add objNewMember
    Else
        mCol.Add objNewMember, sKey
    End If

    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing

End Function

Public Property Get Item(vntIndexKey As Variant) As DockForm
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)
    mCol.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property

Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
End Sub

Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
End Sub
