VERSION 5.00
Begin VB.UserControl TabDockHost 
   Alignable       =   -1  'True
   ClientHeight    =   2880
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   804
   ControlContainer=   -1  'True
   EditAtDesignTime=   -1  'True
   ScaleHeight     =   2880
   ScaleWidth      =   804
End
Attribute VB_Name = "TabDockHost"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'----------------------------------------------------------
' Control: TabDockHost.ctl
' Author : Marclei V Silva (marclei@spnorte.com)
' Date   : 15/04/2000
' Purpose: Host control to dock forms inside it
'
' Revisions
' ---------
'   Date            Author      Remarks
'   01/05/2000      MVS         Cleaned up doc
'   06/05/2000      MVS         Added Style Property
'---------------------------------------------------------

Private Const BF_SOFT = &H1000 ' For softer buttons
Private Const BDR_RAISEDOUTER = &H1

Private Const m_SiteWidth = 1100
Private Const m_SiteHeight = 500

' Docked Form Skin (to be used with changeFormEffect Function)
Private Const SHOW_NORMAL = 0
Private Const SHOW_TRANSPARENT = 1

' Minimum allowed sizes for any PictureBox.
Private Const MIN_HORIZONTAL = 10
Private Const MIN_VERTICAL = 10
'Private Const DEFAULT_HEIGHT = 200

' Drag directions.
Private Const DRAG_NONE = 0
Private Const DRAG_HORIZONTAL = 1
Private Const DRAG_VERTICAL = 2
Private Const DRAG_BOTH = 3

' Private vars
Private m_bPainting As Boolean
Private m_bInitializing As Boolean
Private m_bDirty As Boolean         ' Flag that indicates the
                                    ' docked forms must be resized
Private DragDir As Integer
Private SplitForm As Object
Private cHS As cSplitDDC
Private cVS As cSplitDDC
Private deltaY As Integer           ' X offset when splitting
Private deltaX As Integer           ' Y offset when splitting
Private m_Parent As TabDock
Private m_bEmpty As Boolean

'Event Declarations:
Event FormDock()
Event FormUndock()

Public Property Set Parent(ByVal New_Parent As TabDock)
    Set m_Parent = New_Parent
End Property

Public Property Get Parent() As TabDock
    Set Parent = m_Parent
End Property

Public Property Let Visible(ByVal vData As Boolean)
    UserControl.Extender.Visible = vData
End Property

Public Property Get Visible() As Boolean
    Visible = UserControl.Extender.Visible
End Property

Public Property Let Top(ByVal vData As Variant)
    UserControl.Extender.Top = vData
End Property

Public Property Get Top() As Variant
    Top = UserControl.Extender.Top
End Property

Public Property Let Left(ByVal vData As Variant)
    UserControl.Extender.Left = vData
End Property

Public Property Get Left() As Variant
    Left = UserControl.Extender.Left
End Property

Public Property Let Width(ByVal vData As Variant)
    UserControl.Width = vData
End Property

Public Property Get Width() As Variant
    Width = UserControl.Width
End Property

Public Property Let Height(ByVal vData As Variant)
    UserControl.Height = vData
End Property

Public Property Get Height() As Variant
    Height = UserControl.Height
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As Integer
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    UserControl_Paint
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
End Sub

Private Sub UserControl_Initialize()
    Set cHS = New cSplitDDC
    With cHS
        .Orientation = espVertical
        .Border(espbleft) = 64
        .Border(espbRight) = 64
        .Top = 0
        .Left = UserControl.Width
    End With
    Set cVS = New cSplitDDC
    With cVS
        .Orientation = espHorizontal
        .Border(espbBottom) = 32
        .Border(espbtop) = 32
        .Border(espbleft) = 2
        .Border(espbRight) = 2
        .Top = 0
        .Left = UserControl.Width
    End With
End Sub

Private Sub UserControl_Terminate()
    Set cHS = Nothing
    Set cVS = Nothing
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim pt As POINTAPI
    Dim i As Integer
    Dim arr() As Variant
    Dim lTop, lBottom
    Dim rc As RECT
    
'    UserControl_Paint
    Set SplitForm = Nothing
    ' Let's check we have vertical splitting
    If OverFormDragArea(X, Y, SplitForm) Then
        GetSplitRect SplitForm, rc
    Else
        GetWindowRect UserControl.Extender.Parent.hwnd, rc
    End If
    ' Clip the cursor so it can't move outside the window:
    ClipCursorRect rc
    If DragDir = DRAG_HORIZONTAL Then
        deltaX = UserControl.Extender.Left
        deltaY = UserControl.Extender.Top
        
        If UserControl.Extender.Align = vbAlignLeft Or UserControl.Extender.Align = vbAlignRight Then
            If m_Parent.Panels(vbAlignTop).Visible Then
                cHS.Border(espbtop) = (m_Parent.Panels(vbAlignTop).Height \ Screen.TwipsPerPixelY) + 2
            Else
                cHS.Border(espbtop) = 2
            End If
            If m_Parent.Panels(vbAlignBottom).Visible Then
                cHS.Border(espbBottom) = (m_Parent.Panels(vbAlignBottom).Height \ Screen.TwipsPerPixelY) + 2
            Else
                cHS.Border(espbBottom) = 2
            End If
        End If
        cHS.SplitterMouseDown UserControl.Extender.Parent.hwnd, X, Y
        LockWindowUpdate Extender.Parent.hwnd
        If UserControl.Extender.Align = vbAlignLeft Then
            UserControl.Extender.Width = cHS.Left
        ElseIf UserControl.Extender.Align = vbAlignRight Then
            deltaX = deltaX - cHS.Left
            UserControl.Extender.Width = UserControl.Extender.Width + deltaX
        ElseIf UserControl.Extender.Align = vbAlignTop Then
            Extender.Visible = False
            Extender.Top = 1000
            Extender.Height = cHS.Top
            Extender.Visible = True
            m_bDirty = True
        ElseIf UserControl.Extender.Align = vbAlignBottom Then
            deltaY = deltaY - cHS.Top
            Extender.Visible = False
            ''Extender.Align = vbAlignNone
            Extender.Top = 0
            Extender.Height = UserControl.Extender.Height + deltaY
            ''Extender.Align = vbAlignBottom
            Extender.Visible = True
            m_bDirty = True
        End If
        LockWindowUpdate 0
    ElseIf DragDir = DRAG_VERTICAL Then
        GetCursorPos pt
        deltaY = pt.Y
        If UserControl.Extender.Align = vbAlignLeft Then
            cVS.Border(espbRight) = (UserControl.Extender.Parent.Width - UserControl.Width) \ Screen.TwipsPerPixelX
            cVS.Border(espbleft) = 2
        Else
            cVS.Border(espbRight) = 2
            cVS.Border(espbleft) = (UserControl.Extender.Parent.Width - UserControl.Width) \ Screen.TwipsPerPixelX
        End If
        cVS.SplitterMouseDown UserControl.Extender.Parent.hwnd, X, Y
        GetCursorPos pt
        deltaY = (pt.Y - deltaY) * Screen.TwipsPerPixelY
    End If
    ' Release mouse capture:
    ReleaseCapture
    ' Release the cursor clipping region (must do this!):
    ClipCursorClear 0&
    UserControl_Paint
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim over As Integer
    ' Set the correct arrow type.
    over = OverDragArea(X, Y)
    Select Case over
        Case DRAG_HORIZONTAL
            If UserControl.Extender.Align = vbAlignLeft Or _
                UserControl.Extender.Align = vbAlignRight Then
                UserControl.MousePointer = vbSizeWE
                cHS.Orientation = espVertical
            ElseIf UserControl.Extender.Align = vbAlignTop Or _
                UserControl.Extender.Align = vbAlignBottom Then
                UserControl.MousePointer = vbSizeNS
                cHS.Orientation = espHorizontal
            End If
        Case DRAG_VERTICAL
            UserControl.MousePointer = vbSizeNS
        Case Else
            UserControl.MousePointer = vbDefault
    End Select
    DragDir = over
End Sub

' Return drag flags indicating the area at this point.
Private Function OverDragArea(ByVal X As Single, ByVal Y As Single)
    Dim over As Integer
    ' initially dragging is none
    over = DRAG_NONE
    If UserControl.Extender.Align = vbAlignLeft And _
          X > UserControl.Width - SPLITTER_WIDTH And _
          X < UserControl.Width Then
       over = DRAG_HORIZONTAL
    ElseIf UserControl.Extender.Align = vbAlignRight And _
          X > 0 And _
          X < SPLITTER_WIDTH Then
       over = DRAG_HORIZONTAL
    ElseIf Extender.Align = vbAlignTop And _
        Y > UserControl.Height - SPLITTER_HEIGHT And _
        Y < UserControl.Height Then
       over = DRAG_HORIZONTAL
    ElseIf Extender.Align = vbAlignBottom And _
          Y > 0 And _
          Y < SPLITTER_HEIGHT Then
       over = DRAG_HORIZONTAL
    Else
        If OverFormDragArea(X, Y) Then
            over = DRAG_VERTICAL
        End If
    End If
    OverDragArea = over
End Function

Private Sub UserControl_Paint()
    On Error Resume Next
    If m_bPainting = True Then Exit Sub
    m_bPainting = True
    With UserControl
        .Cls
        If m_bDirty Then
            DockResize
            m_bDirty = False
        End If
        Arrange
    End With
    m_bPainting = False
End Sub

Private Sub UserControl_Resize()
    m_bDirty = True
    UserControl_Paint
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
    UserControl.Refresh
End Sub

Public Sub DockResize()
    Dim F As Form
    Dim lHeight As Long
    Dim lWidth As Long
    Dim lTop As Long
    Dim lLeft As Long
    Dim Count As Integer
    Dim i As Integer
    Dim arr() As Variant
    
    m_bEmpty = False
    If UserControl.ContainedControls.Count = 0 Then
        m_bEmpty = True
        Exit Sub
    End If
    Count = SwapForm(arr)
    If Count = 0 Then
        m_bEmpty = True
        Exit Sub
    End If
    lLeft = 0
    lTop = 0
    lHeight = UserControl.ScaleHeight
    If Extender.Align = vbAlignLeft Or Extender.Align = vbAlignRight Then
        lWidth = UserControl.ScaleWidth - SPLITTER_WIDTH
        lHeight = (lHeight - ((Count - 1) * SPLITTER_HEIGHT)) / Count
        If Extender.Align = vbAlignRight Then
            lLeft = lLeft + SPLITTER_WIDTH
        End If
    ElseIf Extender.Align = vbAlignTop Or Extender.Align = vbAlignBottom Then
        lWidth = UserControl.ScaleWidth
        lHeight = (lHeight - (Count * SPLITTER_HEIGHT)) / Count
        If Extender.Align = vbAlignBottom Then
            lTop = lTop + SPLITTER_HEIGHT
        End If
    End If
    On Error Resume Next
    For i = LBound(arr) To UBound(arr)
        If arr(i).Visible Then
            arr(i).Move lLeft, lTop, lWidth, lHeight
            lTop = lTop + lHeight + SPLITTER_HEIGHT
        End If
    Next
End Sub

Public Sub Arrange()
    Dim lHeight As Long
    Dim lWidth As Long
    Dim lTop As Long
    Dim lLeft As Long
    Dim i As Integer
    Dim CurrentH As Long
    Dim NextH As Long
    Dim arr() As Variant
    
    m_bEmpty = False
    If UserControl.ContainedControls.Count = 0 Then
        m_bEmpty = True
        Exit Sub
    End If
    If SwapForm(arr) = 0 Then
        m_bEmpty = True
        Exit Sub
    End If
    lLeft = 0
    lTop = 0
    If Extender.Align = vbAlignLeft Or _
        Extender.Align = vbAlignRight Then
        lWidth = UserControl.ScaleWidth - SPLITTER_WIDTH
        If Extender.Align = vbAlignRight Then
            lLeft = lLeft + SPLITTER_WIDTH
        End If
    ElseIf Extender.Align = vbAlignTop Or _
        Extender.Align = vbAlignBottom Then
        lWidth = UserControl.ScaleWidth
        If Extender.Align = vbAlignBottom Then
            lTop = lTop + SPLITTER_HEIGHT
        End If
    End If
    For i = LBound(arr) To UBound(arr)
        If arr(i).Visible Then
            If arr(i) Is SplitForm Then
                CurrentH = (arr(i).Height + deltaY)
                NextH = (arr(i + 1).Height - deltaY)
                Set SplitForm = Nothing
            ElseIf NextH > 0 Then
                CurrentH = NextH
                NextH = 0
            Else
                CurrentH = arr(i).Height
            End If
            lHeight = CurrentH
            arr(i).Move lLeft, lTop, lWidth, lHeight
            ShowWindow arr(i).hwnd, SW_SHOWNORMAL
            UpdateWindow arr(i).hwnd
            ' Set the form transparency
            changeFormEffect arr(i), SHOW_TRANSPARENT
            lTop = lTop + lHeight + SPLITTER_HEIGHT
        End If
    Next
End Sub

Private Function ClassName(ByVal lHwnd As Long) As String
    Dim lLen As Long
    Dim sBuf As String
    
    lLen = 260
    sBuf = String(lLen, 0)
    lLen = GetClassName(lHwnd, sBuf, lLen)
    If (lLen <> 0) Then
        ClassName = Left(sBuf, lLen)
    End If
End Function

Private Function SwapForm(iArray() As Variant) As Integer
    Dim idx As Integer
    Dim ct As Integer
    If UserControl.ContainedControls.Count = 0 Then Exit Function
    ct = -1
    For idx = 0 To UserControl.ContainedControls.Count - 1
        If UserControl.ContainedControls(idx).Visible Then
            ct = ct + 1
            ReDim Preserve iArray(ct)
            Set iArray(ct) = UserControl.ContainedControls(idx)
        End If
    Next
    If ct <> -1 Then
        DockSort iArray
    End If
    SwapForm = ct + 1
End Function

Private Sub DockHide(hWnda)
    ' hide window
    Call ShowWindow(hWnda, SW_HIDE)
    UserControl_Paint
End Sub

Private Sub DockSort(iArray())
    Dim lLoop1 As Long
    Dim lLoop2 As Long
    Dim lTemp As Variant
         
    For lLoop1 = UBound(iArray) To LBound(iArray) Step -1
        For lLoop2 = LBound(iArray) + 1 To lLoop1
            If iArray(lLoop2 - 1).Top > iArray(lLoop2).Top Then
                Set lTemp = iArray(lLoop2 - 1)
                Set iArray(lLoop2 - 1) = iArray(lLoop2)
                Set iArray(lLoop2) = lTemp
            End If
        Next lLoop2
    Next lLoop1
End Sub

Private Function OverFormDragArea(X As Single, Y As Single, Optional SplitForm As Object) As Boolean
    Dim i As Integer
    Dim lTop As Long
    Dim arr() As Variant
    Dim Count As Integer
    
    On Error GoTo process_error
    OverFormDragArea = False
    If UserControl.ContainedControls.Count = 0 Then Exit Function
    ' gets the fake Z-Order array
    If SwapForm(arr) = 0 Then Exit Function
    lTop = 0
    Count = UBound(arr)
    If Extender.Align = vbAlignTop Then
        Count = Count - 1
    ElseIf Extender.Align = vbAlignBottom Then
        lTop = lTop + SPLITTER_HEIGHT
    End If
    For i = LBound(arr) To Count
        lTop = lTop + arr(i).Height
        If Y >= lTop And Y <= lTop + SPLITTER_HEIGHT Then
            OverFormDragArea = True
            Set SplitForm = arr(i)
            Exit Function
        End If
    Next
process_error:
End Function

Private Sub GetSplitRect(SplitForm As Object, rc As RECT)
    Dim i As Integer
    Dim lTop As Long
    Dim arr() As Variant
    Dim lBottom As Long
    If UserControl.ContainedControls.Count = 0 Then Exit Sub
    ' gets the fake Z-Order array
    If SwapForm(arr) = 0 Then Exit Sub
    For i = LBound(arr) To UBound(arr)
        If arr(i) Is SplitForm Then
            GetWindowRect SplitForm.hwnd, rc
            lTop = rc.Top + GetSystemMetrics(SM_CYBORDER) * 3 + GetSystemMetrics(SM_CYCAPTION)
            GetWindowRect arr(i + 1).hwnd, rc
            lBottom = rc.Bottom - (GetSystemMetrics(SM_CYBORDER) * 3 + GetSystemMetrics(SM_CYCAPTION))
            rc.Top = lTop
            rc.Bottom = lBottom
            Exit Sub
        End If
        'lTop = lTop + arr(i).Height
    Next
End Sub

' All credits for this code to vbWeb:
Public Sub UnDockShow(F, Optional MoveToLast As Boolean = False)
    Dim hWnda As Long
    Dim style As Long
    ' loads the form if it wasn't loaded yet!
    If IsNumeric(F) Then
        hWnda = F
    Else
        Load F
        hWnda = F.hwnd
    End If
    If Align = vbAlignTop Then Top = 1000
    If Align = vbAlignBottom Then Top = 0
    ' first of all let's hide this window
    ShowWindow hWnda, SW_HIDE
    ' change form's style
    style = GetWindowLong(hWnda, GWL_STYLE)
    style = style And Not WS_DLGFRAME
    style = style Or WS_CAPTION
    style = style Or WS_THICKFRAME
    SetWindowLong hWnda, GWL_STYLE, style
    ' set the parent 0 (tricky!)
    Call SetParent(hWnda, 0)
    ' show the window
    ShowWindow hWnda, SW_SHOW
    ' clear transparency mask used to dock the form
    SetWindowRgn hWnda, 0, True
    'make the form 'float' above the MDI form
    SetWindowLong hWnda, GWL_HWNDPARENT, Extender.Parent.hwnd
    ' give way to windows
    DoEvents
    ' needs to calc heights
    m_bDirty = True
    ' repaint the control
    UserControl_Paint
    m_Parent.UnDock hWnda
    ' project is visible if there is more forms docked...
    If UserControl.ContainedControls.Count = 0 Then
        Extender.Visible = False
        RestoreSitePos
    End If
End Sub

' All credits for this code to VbWeb resources:
Public Sub Dock(F, Align As Integer)
    Dim hWnda As Long
    Dim style As Long
    If IsNumeric(F) Then
        hWnda = F
    Else
        Load F
        hWnda = F.hwnd
    End If
    If Align = vbAlignNone Then
        UnDockShow hWnda
    Else
        If Align = vbAlignTop Then Top = 1000
        If Align = vbAlignBottom Then Top = 0
        ' hide window
        Call ShowWindow(hWnda, SW_HIDE)
        ' change the forms parent to the host container
        style = WS_CAPTION              ' have a caption
        style = style Or WS_DLGFRAME    ' have dialog frame
        style = style Or WS_SYSMENU     ' have sysmenu close button
        SetWindowLong hWnda, GWL_STYLE, style
        SetWindowLong hWnda, GWL_EXSTYLE, WS_EX_TOOLWINDOW ' is a toolwindow
        ' set the parent to the dock host
        Call SetParent(hWnda, hwnd)
        ' show the container once we have have a new form
        Extender.Visible = True
        ' give way to windows
        DoEvents
        ' show docked window
        Call ShowWindow(hWnda, SW_SHOW)
        ' activate it please!
        Call SendMessage(hWnda, WM_NCACTIVATE, 1, 0)
        ' needs to calc heights set this var to True
    End If
    m_Parent.Dock hWnda
    m_bDirty = True
    ' repaint the control
    UserControl_Paint
End Sub

Public Function IsDocked(hWnda As Long) As Boolean
    Dim idx As Integer
    IsDocked = False
    If UserControl.ContainedControls.Count = 0 Then Exit Function
    For idx = 0 To UserControl.ContainedControls.Count - 1
        If UserControl.ContainedControls(idx).hwnd = hWnda Then
            IsDocked = True
            Exit Function
        End If
    Next
End Function

' All credit for this code go to Herman Liu from
' "TrasnparentForm project":
Private Sub changeFormEffect(F, inEffect As Integer)
    Dim W As Single, h As Single
    Dim edge As Single, topEdge As Single
    Dim mLeft, mTop
    Dim i As Integer
    Dim r As Long
    Dim outer As Long, inner As Long
    Dim mFormRegion As Long
    Dim ww As Single, hh As Single
    
    With F
        ' Put width/height in same denomination of scalewidth/scaleheight
        W = .ScaleX(.Width, vbTwips, vbPixels)
        h = .ScaleY(.Height, vbTwips, vbPixels)
        ww = .ScaleX(.ScaleWidth, vbTwips, vbPixels)
        hh = .ScaleY(.ScaleHeight, vbTwips, vbPixels)
        If inEffect = 0 Then
            mFormRegion = CreateRectRgn(0, 0, W, h)
            SetWindowRgn .hwnd, mFormRegion, True
            Exit Sub
        End If
        mFormRegion = CreateRectRgn(0, 0, 0, 0)
        ' Frame edges measurement
        edge = (W - ww) / 2
        topEdge = (h - edge - hh)
        ' Get frame
        If inEffect = 1 Then
            outer = CreateRectRgn(0, 0, W, h)
            inner = CreateRectRgn(0, topEdge, W, h)
            CombineRgn mFormRegion, outer, inner, RGN_DIFF
            ' caption
            outer = CreateRectRgn(0, 0, W, topEdge)
            inner = CreateRectRgn(edge, edge, W - edge, topEdge)
            CombineRgn mFormRegion, outer, inner, RGN_AND
        End If
        ' This error handling is necessary because of
        ' design-time only controls
        On Error Resume Next
        ' Combine regions of controls on form
        For i = 0 To .Controls.Count - 1
            If .Controls(i).Visible = True Then
                mLeft = .ScaleX(.Controls(i).Left, .ScaleMode, vbPixels) + edge
                mTop = .ScaleX(.Controls(i).Top, .ScaleMode, vbPixels) + topEdge
                r = CreateRectRgn(mLeft, mTop, _
                    mLeft + .ScaleX(.Controls(i).Width, .ScaleMode, vbPixels), _
                    mTop + .ScaleY(.Controls(i).Height, .ScaleMode, vbPixels))
                CombineRgn mFormRegion, r, mFormRegion, RGN_OR
            End If
        Next
    End With
    ' We allow toggle
    SetWindowRgn F.hwnd, mFormRegion, True
    DeleteObject mFormRegion
End Sub

Public Property Get Controls() As Object
    Set Controls = UserControl.ContainedControls
End Property

Private Sub RestoreSitePos()
    If Align = vbAlignRight Or Align = vbAlignLeft Then
        Extender.Width = m_SiteWidth
    ElseIf Align = vbAlignBottom Or Align = vbAlignTop Then
        Extender.Height = m_SiteHeight
    End If
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get Align() As Integer
    Align = Extender.Align
End Property

Public Property Let Align(ByVal New_Align As Integer)
    Extender.Align = New_Align
End Property
