VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSplitDDC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
' ======================================================================
' Class:    cSplitDDC
' Filename: cSplitDC.cls
' Author:   SP McMahon
' Date:     07 July 1998
'
' A splitter class using the Desktop window to draw a
' splitter bar, therefore allowing splitting of MDI forms
' as well as standard forms.
' ======================================================================

' REMARKS
' This code was extract from vbaccelarator web site and modified
' to acomplish the requirements of this project
'
' Thanks! to SP McMahon
'
' Modifications
' -------------
'
' -  The splitter object (and further calls to it) was replaced
'    by Top and Left properties once the Userobject TabDockHost
'    is already the bounds for splitting actions
'
' -  The events FormMouseMove and FormMouseUp was put together
'    in the FormMouseDown Event to supply a immediate split
'    drawing for TabDock UserControl
'
' -  The Clipping area (MouseDown() event) is now handled by
'    the TabDockHost MouseDown() event once this event calculates
'    the rectangle of the docked window

'// some global declarations
Private bDraw As Boolean
Private rcCurrent As RECT
Private rcNew As RECT
Private rcWindow As RECT
Private m_sTop As Single
Private m_sLeft As Single

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateDCAsNull Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, lpDeviceName As Any, lpOutput As Any, lpInitData As Any) As Long
Private Declare Function SetROP2 Lib "gdi32" (ByVal hdc As Long, ByVal nDrawMode As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Sub ClipCursorRect Lib "user32" Alias "ClipCursor" (lpRect As RECT)
Private Declare Sub ClipCursorClear Lib "user32" Alias "ClipCursor" (ByVal lpRect As Long)
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Const R2_BLACK = 1       '   0
Private Const R2_COPYPEN = 13    '  P
Private Const R2_LAST = 16
Private Const R2_MASKNOTPEN = 3  '  DPna
Private Const R2_MASKPEN = 9     '  DPa
Private Const R2_MASKPENNOT = 5  '  PDna
Private Const R2_MERGENOTPEN = 12        '  DPno
Private Const R2_MERGEPEN = 15   '  DPo
Private Const R2_MERGEPENNOT = 14        '  PDno
Private Const R2_NOP = 11        '  D
Private Const R2_NOT = 6 '  Dn
Private Const R2_NOTCOPYPEN = 4  '  PN
Private Const R2_NOTMASKPEN = 8  '  DPan
Private Const R2_NOTMERGEPEN = 2 '  DPon
Private Const R2_NOTXORPEN = 10  '  DPxn
Private Const R2_WHITE = 16      '   1
Private Const R2_XORPEN = 7      '  DPx

Private Const SM_CXBORDER = 5
Private Const SM_CYBORDER = 6
Private Const SM_CYCAPTION = 4
Private Const SM_CYMENU = 15

Public Enum eOrientationConstants
    espVertical = 1
    espHorizontal = 2
End Enum

Private m_hWnd As Long
Private m_eOrientation As eOrientationConstants
Private m_lBorder(1 To 4) As Long

Public Enum ESplitBorderTypes
   espbleft = 1
   espbtop = 2
   espbRight = 3
   espbBottom = 4
End Enum

Private m_bIsMDI As Boolean
Private m_bSplitting As Boolean

' MVS: Top and Left properties were created to replace
' the split object
Public Property Let Top(vData As Single)
    m_sTop = vData
End Property

Public Property Get Top() As Single
    Top = m_sTop
End Property

Public Property Let Left(vData As Single)
    m_sLeft = vData
End Property

Public Property Get Left() As Single
    Left = m_sLeft
End Property

Public Property Let Border(ByVal eBorderType As ESplitBorderTypes, ByVal lSize As Long)
   m_lBorder(eBorderType) = lSize
End Property

Public Property Get Border(ByVal eBorderType As ESplitBorderTypes) As Long
   Border = m_lBorder(eBorderType)
End Property

Public Property Get Orientation() As eOrientationConstants
    Orientation = m_eOrientation
End Property

Public Property Let Orientation(ByVal eOrientation As eOrientationConstants)
    m_eOrientation = eOrientation
    If (m_eOrientation = espHorizontal) Then
        m_lBorder(espbtop) = 64
        m_lBorder(espbBottom) = 64
        m_lBorder(espbleft) = 0
        m_lBorder(espbRight) = 0
    Else
        m_lBorder(espbtop) = 0
        m_lBorder(espbBottom) = 0
        m_lBorder(espbleft) = 64
        m_lBorder(espbRight) = 64
    End If
End Property

Public Sub SplitterMouseDown( _
        ByVal hwnd As Long, _
        ByVal X As Long, _
        ByVal Y As Long _
    )
    Dim tp As POINTAPI
    Dim tpPrev As POINTAPI
    
    m_hWnd = hwnd

    ' Send subsequent mouse messages to the owner window
    SetCapture m_hWnd
    ' Get the window rectangle on the desktop of the owner window:
    GetWindowRect m_hWnd, rcWindow
    
' MVS:
'    ' Clip the cursor so it can't move outside the window:
'    ClipCursorRect rcWindow
'
    ' Check if this is an MDI form:
    If (ClassName(m_hWnd) = "ThunderMDIForm") Then
        ' Get the inside portion of the MDI form:
        ' I'm assuming you have a caption,menu and border in your MDI here
        rcWindow.Left = rcWindow.Left + GetSystemMetrics(SM_CXBORDER)
        rcWindow.Right = rcWindow.Right - GetSystemMetrics(SM_CXBORDER)
        rcWindow.Bottom = rcWindow.Bottom - GetSystemMetrics(SM_CYBORDER)
        rcWindow.Top = rcWindow.Top + GetSystemMetrics(SM_CYBORDER) * 3 + GetSystemMetrics(SM_CYCAPTION)
        If GetMenuItemCount(GetMenu(m_hWnd)) Then
            rcWindow.Top = rcWindow.Top + GetSystemMetrics(SM_CYMENU)
        End If
        m_bIsMDI = True
    Else
        ' Get the client rectangle of the window in screen coordinates:
        GetClientRect m_hWnd, rcWindow
        tp.X = rcWindow.Left
        tp.Y = rcWindow.Top
        ClientToScreen m_hWnd, tp
        rcWindow.Left = tp.X
        rcWindow.Top = tp.Y
        tp.X = rcWindow.Right
        tp.Y = rcWindow.Bottom
        ClientToScreen m_hWnd, tp
        rcWindow.Right = tp.X
        rcWindow.Bottom = tp.Y
        m_bIsMDI = False
    End If
    'Store the initial cursor position
    tpPrev.X = tp.X
    tpPrev.Y = tp.Y
    
    bDraw = True  '// start actual drawing from next move message
    
    rcCurrent.Left = 0: rcCurrent.Top = 0: rcCurrent.Right = 0: rcCurrent.Bottom = 0
    
    X = (Left + X) \ Screen.TwipsPerPixelX
    Y = (Top + Y) \ Screen.TwipsPerPixelY

' MVS: All the events are in this same handler, cause i don't
' need to have event handling in my UserControl and this is
' more direct!
    
    SplitterFormMouseMove tp.X, tp.Y
    Do While GetKeyState(VK_LBUTTON) < 0
        GetCursorPos tp
        If tp.X <> tpPrev.X Or tp.Y <> tpPrev.Y Then
            tpPrev.X = tp.X
            tpPrev.Y = tp.Y
            SplitterFormMouseMove tp.X, tp.Y
        End If
        DoEvents
    Loop
    SplitterFormMouseUp tp.X, tp.Y
End Sub

Public Sub SplitterFormMouseMove( _
      ByVal X As Long, _
      ByVal Y As Long)
Dim hdc As Long
Dim tp As POINTAPI
Dim hWndClient As Long
    If (bDraw) Then
        '// Draw two rectangles in the screen DC to cause splitting:
        
        ' First get the Desktop DC:
        hdc = CreateDCAsNull("DISPLAY", ByVal 0&, ByVal 0&, ByVal 0&)
        ' Set the draw mode to XOR:
        SetROP2 hdc, R2_NOTXORPEN
    
        '// Draw over and erase the old rectangle
        ' (if this is the first time, all the coords will be 0 and nothing will get drawn):
        Rectangle hdc, rcCurrent.Left, rcCurrent.Top, rcCurrent.Right, rcCurrent.Bottom
                
        ' It is simpler to use the mouse cursor position than try to translate
        ' X,Y to screen coordinates!
        GetCursorPos tp
        
        ' Determine where to draw the splitter:
        If (m_eOrientation = espHorizontal) Then
            rcNew.Left = rcWindow.Left + m_lBorder(espbleft)
            rcNew.Right = rcWindow.Right - m_lBorder(espbRight)
            If (tp.Y >= rcWindow.Top + m_lBorder(espbtop)) And (tp.Y < rcWindow.Bottom - m_lBorder(espbBottom)) Then
                rcNew.Top = tp.Y - 2
                rcNew.Bottom = tp.Y + 2
            Else
                If (tp.Y < rcWindow.Top + m_lBorder(espbtop)) Then
                    rcNew.Top = rcWindow.Top + m_lBorder(espbtop) - 2
                    rcNew.Bottom = rcNew.Top + 5
                Else
                    rcNew.Top = rcWindow.Bottom - m_lBorder(espbBottom) - 2
                    rcNew.Bottom = rcNew.Top + 5
                End If
            End If
        Else
            rcNew.Top = rcWindow.Top + m_lBorder(espbtop)
            rcNew.Bottom = rcWindow.Bottom - m_lBorder(espbBottom)
            If (tp.X >= rcWindow.Left + m_lBorder(espbleft)) And (tp.X <= rcWindow.Right - m_lBorder(espbRight)) Then
                rcNew.Left = tp.X - 2
                rcNew.Right = tp.X + 2
            Else
                If (tp.X < rcWindow.Left + m_lBorder(espbleft)) Then
                    rcNew.Left = rcWindow.Left + m_lBorder(espbleft) - 2
                    rcNew.Right = rcNew.Left + 5
                Else
                    rcNew.Left = rcWindow.Right - m_lBorder(espbRight) - 2
                    rcNew.Right = rcNew.Left + 5
                End If
            End If
        End If
        
        '// Draw the new rectangle
        Rectangle hdc, rcNew.Left, rcNew.Top, rcNew.Right, rcNew.Bottom
        
        ' Store this position so we can erase it next time:
        LSet rcCurrent = rcNew
        
        ' Free the reference to the Desktop DC we got (make sure you do this!)
        DeleteDC hdc
    End If
    
End Sub

Public Function SplitterFormMouseUp( _
      ByVal X As Long, _
      ByVal Y As Long _
   ) As Boolean
Dim hdc As Long
Dim tp As POINTAPI
Dim hWndClient As Long

      '// Don't leave orphaned rectangle on desktop; erase last rectangle.
   If (bDraw) Then
       bDraw = False
       
       ' Release mouse capture:
       ReleaseCapture
       ' Release the cursor clipping region (must do this!):
       ClipCursorClear 0&
       
       ' Get the Desktop DC:
       hdc = CreateDCAsNull("DISPLAY", 0, 0, 0)
       ' Set to XOR drawing mode:
       SetROP2 hdc, R2_NOTXORPEN
       ' Erase the last rectangle:
       Rectangle hdc, rcCurrent.Left, rcCurrent.Top, rcCurrent.Right, rcCurrent.Bottom
       ' Clear up the desktop DC:
       DeleteDC hdc
       
       ' Here we ensure the splitter is within bounds before releasing:
       GetCursorPos tp

       If (tp.X < rcWindow.Left + m_lBorder(espbleft)) Then
           tp.X = rcWindow.Left + m_lBorder(espbleft)
       End If
       If (tp.X > rcWindow.Right - m_lBorder(espbRight)) Then
           tp.X = rcWindow.Right - m_lBorder(espbRight)
       End If
       If (tp.Y < rcWindow.Top + m_lBorder(espbtop)) Then
           tp.Y = rcWindow.Top + m_lBorder(espbtop)
       End If
       If (tp.Y > rcWindow.Bottom - m_lBorder(espbBottom)) Then
           tp.Y = rcWindow.Bottom - m_lBorder(espbBottom)
       End If
       ScreenToClient m_hWnd, tp
       
       ' Move the splitter to the validated final position:
       If (m_eOrientation = espHorizontal) Then
           Top = (tp.Y - 2) * Screen.TwipsPerPixelY
       Else
           Left = (tp.X - 2) * Screen.TwipsPerPixelX
       End If
       
       ' Return true to tell the owner we have completed splitting:
       SplitterFormMouseUp = True
   End If
   
End Function

Private Sub Class_Initialize()
   m_eOrientation = espVertical
   m_lBorder(espbleft) = 64
   m_lBorder(espbRight) = 64
End Sub

Private Function ClassName(ByVal lHwnd As Long) As String
Dim lLen As Long
Dim sBuf As String
    lLen = 260
    sBuf = String$(lLen, 0)
    lLen = GetClassName(lHwnd, sBuf, lLen)
    If (lLen <> 0) Then
        ClassName = Left$(sBuf, lLen)
    End If
End Function
